]> git.pld-linux.org Git - packages/apache.git/blobdiff - apache.init
- up to 2.0.59
[packages/apache.git] / apache.init
index 922ef7f188e8f078e2ba6d9b867b853e45e1c3dd..fe83adda65bbb608999d4281d0bc6be8ca9c6350 100644 (file)
 . /etc/sysconfig/network
 
 # Get service config
-[ -f /etc/sysconfig/apache ] && . /etc/sysconfig/apache
+[ -f /etc/sysconfig/httpd ] && . /etc/sysconfig/httpd
 
 # Check that networking is up.
-if [ "${NETWORKING}" = "no" ]; then
-       echo "WARNING: Networking is down. Apache can't be runed."
+if is_yes "${NETWORKING}"; then
+       if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
+               # nls "ERROR: Networking is down. %s can't be run." <service>
+               msg_network_down httpd
+               exit 1
+       fi
+else
+       exit 0
+fi
+
+[ -z "$HTTPD_MPM" ] && HTTPD_MPM="prefork"
+if [ -d "${HTTPD_CONF:-'/etc/httpd/httpd.conf'}" ]; then
+       CFG="-f ${HTTPD_CONF:-'/etc/httpd/httpd.conf'}"
+elif [ -n "$HTTPD_CONF" ]; then
+       echo "error: HTTPD_CONF='$HTTPD_CONF': not a file, not a directory"
        exit 1
+else
+       CFG=""
 fi
 
+RETVAL=0
 # See how we were called.
 case "$1" in
   start)
        # Check if the service is already running?
        if [ ! -f /var/lock/subsys/httpd ]; then
-               show Starting httpd
-               daemon httpd
-               touch /var/lock/subsys/httpd
+               msg_starting httpd.${HTTPD_MPM}
+               daemon httpd.${HTTPD_MPM} $CFG $HTTPD_OPTS
+               RETVAL=$?
+               [ $RETVAL -eq 0 ] && touch /var/lock/subsys/httpd
        else
-               echo "httpd already is running"
+               msg_already_running httpd.${HTTPD_MPM}
        fi
        ;;
   stop)
-       show Shutting down httpd
-       killproc httpd  
-       rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc*
+       # Stop daemons.
+       if [ -f /var/lock/subsys/httpd ]; then
+               msg_stopping httpd.${HTTPD_MPM}
+               [ -n "$(pidofproc httpd.${HTTPD_MPM})" ] && OPT="--waitforname httpd.${HTTPD_MPM} --waitfortime 60" || OPT=
+               daemon $OPT httpd.${HTTPD_MPM} $CFG -k stop
+               # Delete pidfile only when apache was called successfully
+               if [ $? -eq 0 ]; then
+                       rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc* >/dev/null 2>&1
+               fi
+       else
+               msg_not_running httpd.${HTTPD_MPM}
+       fi
        ;;
   status)
-       status httpd
-       /usr/sbin/httpd -S
+       status httpd.${HTTPD_MPM}
+       RETVAL=$?
+       /usr/sbin/httpd.${HTTPD_MPM} $CFG -S
        ;;
-  restart|reload)
+  restart)
        $0 stop
        $0 start
        ;;
+  reload|force-reload|graceful)
+       if [ -f /var/lock/subsys/httpd ]; then
+               run_cmd "Checking httpd.${HTTPD_MPM} configuration" httpd.${HTTPD_MPM} $CFG -t
+               RETVAL=$?
+               if [ $RETVAL -eq 0 ]; then
+                       msg_reloading httpd.${HTTPD_MPM}
+                       daemon httpd.${HTTPD_MPM} $CFG -k graceful
+                       RETVAL=$?
+               fi
+       else
+               msg_not_running httpd.${HTTPD_MPM} >&2
+               RETVAL=7
+       fi
+       ;;
   *)
-       echo "Usage: $0 {start|stop|restart|status}"
-       exit 1
+       msg_usage "$0 {start|stop|restart|reload|force-reload|graceful|status}"
+       exit 3
        ;;
 esac
 
-exit 0
+exit $RETVAL
This page took 0.033963 seconds and 4 git commands to generate.